## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.10

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# ArenaBlockBase Class Template Reference

`#include <ArenaBlockBase.hpp>`

Inheritance diagram for ArenaBlockBase:

[legend]
Collaboration diagram for ArenaBlockBase:

[legend]
List of all members.

## Public Types

- typedef ArenaBlockBase<ObjectType,
  SizeType> ThisType
- typedef XalanAllocator<ObjectType> AllocatorType
- typedef SizeType size_type

## Public Methods

- MemoryManagerType& getMemoryManager ()
- bool blockAvailable () const
- bool isEmpty () const
- size_type getCountAllocated () const
- size_type getBlockSize () const
- bool ownsBlock (const ObjectType *theObject) const

## Protected Methods

- ArenaBlockBase (MemoryManagerType &theManager, size_type theBlockSize)
- ~ArenaBlockBase ()
- bool isInBorders (const ObjectType *theObject, size_type rightBoundary) const
- size_type getBlockOffset (const ObjectType *theObject) const
- ObjectType* getBlockAddress (size_type theOffset) const

## Protected Attributes

- AllocatorType m_allocator
- size_type m_objectCount
- const size_type m_blockSize
- ObjectType* m_objectBlock

### template<class ObjectType, class SizeType = size_t> class ArenaBlockBase

## Member Typedef Documentation

template<class ObjectType, class SizeType = size_t>
typedef XalanAllocator< ObjectType > ArenaBlockBase<ObjectType, SizeType>::AllocatorType<ObjectType>

template<class ObjectType, class SizeType = size_t>
typedef ArenaBlockBase< ObjectType, SizeType > ArenaBlockBase<ObjectType, SizeType>::ThisType<ObjectType, SizeType>

| Reimplemented in ArenaBlock, and ReusableArenaBlock.

template<class ObjectType, class SizeType = size_t>
typedef SizeType ArenaBlockBase<ObjectType, SizeType>::size_type

| Reimplemented in ArenaBlock, and ReusableArenaBlock.

## Constructor & Destructor Documentation

template<class ObjectType, class SizeType = size_t>
ArenaBlockBase<ObjectType, SizeType>::ArenaBlockBase<ObjectType, SizeType> ( | MemoryManagerType & theManager,
| size_type theBlockSize )`[protected]`

template<class ObjectType, class SizeType = size_t>
ArenaBlockBase<ObjectType, SizeType>::~ArenaBlockBase<ObjectType, SizeType> ( | )`[protected]`

## Member Function Documentation

template<class ObjectType, class SizeType = size_t>
bool ArenaBlockBase<ObjectType, SizeType>::blockAvailable ( | ) const

template<class ObjectType, class SizeType = size_t>
ObjectType * ArenaBlockBase<ObjectType, SizeType>::getBlockAddress ( | size_type theOffset ) const`[protected]`

template<class ObjectType, class SizeType = size_t>
size_type ArenaBlockBase<ObjectType, SizeType>::getBlockOffset ( | const ObjectType * theObject ) const`[protected]`

template<class ObjectType, class SizeType = size_t>
size_type ArenaBlockBase<ObjectType, SizeType>::getBlockSize ( | ) const

template<class ObjectType, class SizeType = size_t>
size_type ArenaBlockBase<ObjectType, SizeType>::getCountAllocated ( | ) const

template<class ObjectType, class SizeType = size_t>
MemoryManagerType & ArenaBlockBase<ObjectType, SizeType>::getMemoryManager ( | )

template<class ObjectType, class SizeType = size_t>
bool ArenaBlockBase<ObjectType, SizeType>::isEmpty ( | ) const

template<class ObjectType, class SizeType = size_t>
bool ArenaBlockBase<ObjectType, SizeType>::isInBorders ( | const ObjectType * theObject,
| size_type rightBoundary ) const`[protected]`

template<class ObjectType, class SizeType = size_t>
bool ArenaBlockBase<ObjectType, SizeType>::ownsBlock ( | const ObjectType * theObject ) const

## Member Data Documentation

template<class ObjectType, class SizeType = size_t>
AllocatorType ArenaBlockBase<ObjectType, SizeType>::m_allocator`[protected]`

template<class ObjectType, class SizeType = size_t>
const size_type ArenaBlockBase<ObjectType, SizeType>::m_blockSize`[protected]`

template<class ObjectType, class SizeType = size_t>
ObjectType * ArenaBlockBase<ObjectType, SizeType>::m_objectBlock`[protected]`

template<class ObjectType, class SizeType = size_t>
size_type ArenaBlockBase<ObjectType, SizeType>::m_objectCount`[protected]`

The documentation for this class was generated from the following file:

- ArenaBlockBase.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.10 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.